/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * A test service interface with functions using different parameter and return types
 * @author Bryan Aupperle
 *
 */

/* @Remotable */
struct aa {
	int     m;
	char    n[10];
	long    o[5];
};

/**
 * Function for invoking testcase service
 * @param input - input parameter(s) as a string
 * @return - output data as a string
 */
char *operation1(const char *input);

/**
 * Function for invoking testcase service
 * @param input - struct parameter but typed incompatibly.
 * @return - output data as a string
 */
/* @WebParam(paramName="input", type="test:omplexType1") */
char *operation2(struct aa input);
