/*
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 */
package client;


import testClient.TestInvocation;

/**
 * Client for C_6014_TestCase
 * Tests that a component specifying output message formats are not part of the callback interface
 * are result in an error.
 */
public class C_6014_TestCase extends BaseJAXWSTestRunner {

 
    protected TestConfiguration getTestConfiguration() {
    	TestConfiguration config = new TestConfiguration();
    	config.testName 		= this.getClass().getSimpleName().substring(0, 6);
    	config.input 			= "request";
    	config.output[0] 			= config.testName + " " + config.input + " service1 operation1 invoked Test service got an error during execution: Other runtime detected error";
    	config.composite 		= "Test_" + config.testName + ".composite";
    	config.testServiceName 	= "TestClient";
    	config.testClass 		= null;
    	config.contributionNames	= new String[] { "ccni", "ccni_prog" };
    	config.serviceInterface = TestInvocation.class;
    	return config;
    }
    
} // end class Test_C_6014
