/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * A remotable service interface used for a Callback
 * from Service12 with a function that is not part of the callback interface
 * @author Bryan Aupperle
 *
 */

/* @Remotable */
/**
 * Function that is not part of the callback interface
 * @param input - input parameter(s) as a string
 * @return - output data as a string
 */
char *callback1(const char *input);

/**
 * Function for invoking testcase service
 * @param input - input parameter(s) as a string
 * @return - output data as a string
 */
/* @Operation */
char *callback2(const char *input);
