/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1
 * 0 references
 * 1 Boolean and 2 real properties
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "SCA.h"
#include <stdint.h>

/* @Property */
char serviceName[50];

/* @Property(type="xsd:boolean") */
char serviceData1;

/* @Property */
float serviceData2;

/* @Property */
double serviceData3;

char *operation1(const char *input) {
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName;
	char *result, boolval[6];

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	SCAPropertyBoolean(L"serviceData1", &serviceData1, &num_values, &compCode, &reason);
	if (serviceData1)
		strcpy(boolval, "True");
	else
		strcpy(boolval, "False");
	SCAPropertyFloat(L"serviceData2", &serviceData2, &num_values, &compCode, &reason);
	SCAPropertyDouble(L"serviceData3", &serviceData3, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */
	sprintf(result, "%s operation1 invoked %s %f %f\n",
	        serviceName, boolval, serviceData2, serviceData3);
	return result;
};
