/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1
 * 0 references
 * 1 multivalued integral properties
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "SCA.h"
#include <stdint.h>

/* @Property */
char serviceName[50];

/* @Property */
int32_t serviceData[3];

char *operation1(const char *input) {
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName;
	char *result;

	result = (char *)malloc(255);  /* infrastructure must free this */
	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	SCAPropertyInt(L"serviceData", serviceData, &num_values, &compCode, &reason);
	switch (compCode) {
		case (SCACC_WARNING):
			num_values = 3;
			SCAPropertyInt(L"serviceData", serviceData, &num_values, &compCode, &reason);
			sprintf(result, "%s operation1 invoked %li %li\n",
					serviceName, serviceData[0], serviceData[1]);
			break;

		case (SCACC_OK):
			strcpy(result, serviceName);
			strcat(result, " operation1 invoked missing values");
			break;

		default:
			/* Should not get here */
			result[0] = '\0';
	}

	return result;
};
