/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service46
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */


#include "Service1.h"
#include "SCA.h"
#include <unistd.h>

/* @Property */
char serviceName[50];
char async_rsp[255];
SCAREF serviceToken;

/* @Reference(name="reference1", interfaceHeader="Service46.h") */

void operation1Handler(short rspType)
{
	int compCode, reason, size = 255;

	if (rspType == SCA_REPLY_MESSAGE)
		SCAGetReplyMessage(serviceToken, &size, (void *)async_rsp, &compCode, &reason);

	return;
}

char *operation1(const char *input) {
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, response1[255], *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */
	void (*ah)(short) = &operation1Handler;

	SCAGetReference(L"reference1", &serviceToken, &compCode, &reason);
	size = 255;
	SCAInvokeAsync(serviceToken, L"operation1", strlen(input), (void *)input, ah, &compCode, &reason);

	strcpy(result, serviceName);
	strcat(result, " operation1 invoked ");
	sleep(15);
	strcat(result, async_rsp);
	return result;
};
