/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

#include <wchar.h>
#include <stdint.h>
#include <time.h>

/**
 * A test service interface with functions using different parameter and return types
 * @author Bryan Aupperle
 *
 */

/* @Remotable */
/**
 * Function for invoking testcase service
 * @param input - input parameter(s) as a string
 * @return - output data as a string
 */
char *operation1(const char *input);

/**
 * Function for invoking testcase service
 * @param a - int parameter
 * @param b - long parameter
 * @param c - long long parameter
 * @return - output data as a short
 */
short operation2(int a, long b, long long c);

/**
 * Function for invoking testcase service
 * @param a - unsigned int parameter
 * @param b - unsigned long parameter
 * @param c - unsigned long long parameter
 * @return - output data as a unsigned short
 */
unsigned short operation3(unsigned int a, unsigned long b, unsigned long long c);

/**
 * Function for invoking testcase service
 * @param a - signed char parameter
 * @param b - char parameter
 * @return - output data as a unsigned char
 */
unsigned char operation4(signed char a, char b);

/**
 * Function for invoking testcase service
 * @param a - double parameter
 * @param b - long double parameter
 * @return - output data as a float
 */
float operation5(double a, long double b);

/**
 * Function for invoking testcase service
 * @param a - int16_t parameter
 * @param b - int32_t parameter
 * @param c - int64_t  parameter
 * @return - output data as a int8_t
 */
int8_t operation6(int16_t a, int32_t b, int64_t c);

/**
 * Function for invoking testcase service
 * @param a - uint16_t parameter
 * @param b - uint32_t parameter
 * @param c - uint64_t  parameter
 * @return - output data as a uint8_t
 */
uint8_t operation7(uint16_t a, uint32_t b, uint64_t c);

/**
 * Function for invoking testcase service
 * @param a - wide char parameter
 * @return - output data as a wide char string
 */
wchar_t *operation8(wchar_t a);

/**
 * Function for invoking testcase service
 * @param a - time_t parameter
 * @param b - struct tm parameter
 * @return - output data as a _Bool
 */
_Bool operation9(time_t a,  struct tm b);
