/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with two
 * 1 service with interface Service11P
 * 0 references
 * @author Bryan Aupperle
 *
 */


#include "Service11P.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

main () {
    wchar_t myService [255];
    wchar_t myOperation [255];
    struct operation1 request;
    struct operation1Response response;
	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

    SCAService(myService, &compCode, &reason);

    SCAOperation(myOperation, &compCode, &reason);

    if (wcscmp(myOperation,L"operation1") == 0){
    	SCAMessageIn(myService, myOperation, sizeof(struct operation1), (void *)&request,
                     &compCode, &reason);
		strcpy(response.result, serviceName);
		strcat(response.result, " operation1 invoked");

        SCAMessageOut(myService, myOperation, sizeof(struct operation1Response),(void *)&response,
                      &compCode, &reason);
    }
    else if (wcscmp(myOperation,L"operation2") == 0){
    	/* Should not get here but... */
		strcpy(response.result, "operation2 invoked");
        SCAMessageOut(myService, myOperation, sizeof(struct operation1Response),(void *)&response,
                      &compCode, &reason);
    }
};
