/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * C component implementation
 * 1 service with interface Service1
 * 0 references
 *
 * @author Bryan Aupperle
 *
 */

#include "Service5P.h"
#include "SCA.h"

/* @Property */
char serviceName[50];

main () {
    wchar_t myService [255];
    wchar_t myOperation [255];
    struct operation1 request;
    struct operation1Response response;
	SCAREF callbackRef;
   	int compCode, reason, size = 50, num_values = 1;
	char *pServiceName = serviceName, response1[255];

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);
	
    SCAService(myService, &compCode, &reason);

    SCAOperation(myOperation, &compCode, &reason);

    if (wcscmp(myOperation,L"operation1") == 0){
    	SCAMessageIn(myService, myOperation, sizeof(struct operation1), (void *)&request,
                     &compCode, &reason);
		SCAGetCallback(L"", &callbackRef, &compCode, &reason);
		size = 255;
		SCAInvoke(callbackRef, L"callback1", strlen(request.input), (void *)request.input,
	          	&size, (void *)response1, &compCode, &reason);

		SCAReleaseCallback(callbackRef, &compCode, &reason);
		strcpy(response.result, serviceName);
		strcat(response.result, " operation1 invoked ");
		strcat(response.result, response1);
        SCAMessageOut(myService, myOperation, sizeof(struct operation1Response),(void *)&response, 
                      &compCode, &reason);
    }
};
