/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service46
 * reference gets called when service1 operation1 is invoked
 * @author Bryan Aupperle
 *
 */


#include "Service1.h"
#include "SCA.h"
#include <unistd.h>

/* @Property */
char serviceName[50];

/* @Reference(name="reference1", interfaceHeader="Service46.h") */

char *operation1(const char *input) {
	SCAREF serviceToken;
	int compCode, reason, size = 50, num_values = 1;
	short rspType;
	char *pServiceName = serviceName, response1[255], *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */

	SCAGetReference(L"reference1", &serviceToken, &compCode, &reason);
	size = 255;
	SCA_operation1Poll(serviceToken, input);

	strcpy(result, serviceName);
	strcat(result, " operation1 invoked ");

	SCACheckResponse(serviceToken, &rspType, &compCode, &reason);
	while (!rspType) {
		sleep(2);
		SCACheckResponse(serviceToken, &rspType, &compCode, &reason);
	}
	if (rspType == SCA_REPLY_MESSAGE)
		SCAGetReplyMessage(serviceToken, &size, (void *)response1, &compCode, &reason);

	strcat(result, response1);
	return result;
};
