/*
 *
 * Copyright(C) OASIS(R) 2010. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.
 *
 */

/**
 * C component implementation with
 * 1 service with interface Service1,
 * 1 reference (1..1) with interface Service40
 *
 * @author Bryan Aupperle
 *
 */

#include "Service1.h"
#include "SCA.h"

/* @Property */
wchar_t serviceName[50];

/* @Reference(name="reference1", interfaceHeader="Service40.h") */

wchar_t result[255];

wchar_t *operation1(const wchar_t *input) {
	SCAREF serviceToken;
	int compCode, reason, size = 50, num_values = 1;
	wchar_t *pServiceName = serviceName, response1[255], *result;

	SCAPropertyString(L"serviceName", &pServiceName, &size, &num_values, &compCode, &reason);

	result = (wchar_t *)malloc(255);  /* infrastructure must free this */

	SCAGetReference(L"reference1", &serviceToken, &compCode, &reason);
	size = 255;
	SCAInvoke(serviceToken, L"operation1", wcslen(input), (void *)input,
	          &size, (void *)response1, &compCode, &reason);

	wcscpy(result, serviceName);
	wcscat(result, L" operation1 invoked ");
	wcscat(result, response1);

	return result;
};
